#
#     Sam Hadow - Huffman-py
#     Copyright (C) 2023
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from setuptools import setup, find_packages


#  'pip install .' in project directory to install
setup(
    name='huffman_py',
    version='1.0',
    author='Sam Hadow',
    author_email='sam.hadow@inbox.lv',
    license='GPLv3+',
    description='Huffman algorithm implementation in Python, QT GUI',
    package_dir={'huffman_py':'huffman_py'},
    entry_points={
        'console_scripts': [
            'huffman_py=huffman_py.main:main',
        ],
    },
    classifiers=[
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.10',
    ],
    python_requires='>=3.10',
    install_requires=[
    'graphviz>=0.20',
    'PyQt5>=5.15.9',
    'PyQt5-Qt5>=5.15.2',
    'PyQt5-sip>=12.11.1',
    ],
    options={
        'bdist_wheel': {
            'universal': True,
        },
    },
)
